﻿using System.IO;
using System.Windows;
using ThinkGeo.MapSuite;
using ThinkGeo.MapSuite.Layers;
using ThinkGeo.MapSuite.Shapes;
using ThinkGeo.MapSuite.Styles;
using ThinkGeo.MapSuite.Wpf;

namespace _9720
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        RectangleShape rect;

        public MainWindow()
        {
            InitializeComponent();
            //map.CurrentScaleChanged += Map_CurrentScaleChanged;
        }

        private void map_Loaded(object sender, RoutedEventArgs e)
        {
            map.MapUnit = GeographyUnit.DecimalDegree;

            FileBitmapTileCache cache = new FileBitmapTileCache();
            cache.CacheDirectory = @"..\..\AppData";
            cache.CacheId = "LinearCachedTiles";
            cache.ImageFormat = TileImageFormat.Png;

            LayerOverlay layerOverlay = new LayerOverlay();
            layerOverlay.TileCache = cache;

            ShapeFileFeatureLayer shapeFileLayer = new ShapeFileFeatureLayer(@"..\..\AppData\states.shp");
            if (true)
            {
                shapeFileLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Forest1;
            }
            else
            {
                shapeFileLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Water1;
            }
            shapeFileLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            layerOverlay.Layers.Add(shapeFileLayer);
            map.Overlays.Add(layerOverlay);

            shapeFileLayer.Open();
            rect = shapeFileLayer.GetBoundingBox();
            map.CurrentExtent = rect;
            

            //double currentScale = ExtentHelper.GetSnappedScale(rect, (float)map.ActualWidth, map.MapUnit);
            //cache.TileMatrix.Scale = 73823973.75;
            //cache.DeleteTiles(rect);

            //DeleteOldCache(cache, rect, map.ZoomLevelSet);

            map.Refresh();
        }

        public void DeleteOldCache(FileBitmapTileCache cache, RectangleShape rect, ZoomLevelSet zoomLevelSet)
        {
            foreach (ZoomLevel level in zoomLevelSet.GetZoomLevels())
            {
                cache.TileMatrix.Scale = level.Scale;
                cache.DeleteTiles(rect);
            }
        }

        private void Map_CurrentScaleChanged(object sender, CurrentScaleChangedWpfMapEventArgs e)
        {
            //if (thisLevelDeletedFlag)// You can set a flag here to avoid delete many times, it will reduce performance 
            //{
                LayerOverlay overlay = map.Overlays[0] as LayerOverlay;
                overlay.TileCache.TileMatrix.Scale = e.CurrentScale;
                overlay.TileCache.DeleteTiles(rect);
            //}
        }
    }
}
